SystemOrganization addCategory: #PreferenceBrowser!

Object subclass: #PreferenceView
	instanceVariableNames: 'preference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

PreferenceView class
	instanceVariableNames: 'registeredClasses'!

!PreferenceView commentStamp: '<historical>' prior: 0!
My subclasses instances are responsible for building the visual representation of each kind of preference.!

PreferenceView class
	instanceVariableNames: 'registeredClasses'!

PreferenceView subclass: #PBPreferenceView
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBPreferenceView commentStamp: '<historical>' prior: 0!
I am just a refactor of all the common method of the PreferenceBrowser preference views!

PBPreferenceView subclass: #PBBooleanPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBBooleanPreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the visual representation of a preference that accepts true and false values. This view is aimed to be used inside a PreferenceBrowser panel.!

!PBBooleanPreferenceView class methodsFor: 'class initialization' stamp: 'hpt 9/26/2004 15:47'!
initialize
	PreferenceViewRegistry ofBooleanPreferences register: self.
! !

!PBBooleanPreferenceView class methodsFor: 'class initialization' stamp: 'laza 3/19/2010 14:02'!
unload
	"Unload order is not guaranteed so guard against failure"
	[PreferenceViewRegistry ofBooleanPreferences unregister: self] on: Error do:[].! !

!PBBooleanPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 16:42'!
enabledButton
	| aButton |
	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: self preference;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue;
		label: 'enabled' translated;
		yourself.
	^self horizontalPanel
		addMorphBack: aButton;
		yourself.! !

!PBBooleanPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 16:42'!
localToProjectButton
	| aButton |
	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: self preference;
		actionSelector: #toggleProjectLocalness;
		getSelector: #localToProject;
		label: 'local' translated;
		yourself.
	^self horizontalPanel
		addMorphBack: aButton;
		yourself.! !

!PBBooleanPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 16:59'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	^self horizontalPanel
		layoutInset: 2;
		cellInset: 7;
		color: aColor;
		addMorphBack: self morphForName;
		addMorphBack: self horizontalFiller; 
		addMorphBack: self enabledButton;
		addMorphBack: self localToProjectButton;
		yourself.! !

PBPreferenceView subclass: #PBColorPreferenceView
	instanceVariableNames: 'button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBColorPreferenceView class methodsFor: 'class initialization' stamp: 'hpt 12/6/2004 20:49'!
initialize
	PreferenceViewRegistry ofColorPreferences register: self.! !

!PBColorPreferenceView class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 16:33'!
unload
	"Unload order is not guaranteed so guard against failure"
	[PreferenceViewRegistry ofColorPreferences unregister: self] on: Error do:[]! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'kfr 5/6/2015 20:42'!
adjustLabelColor
	| textColor |
	(self preference preferenceValue luminance < 0.5)
		ifTrue:[ textColor := Color white]
		ifFalse:[ textColor := Color black].
	button allMorphsDo: [:m | (m isKindOf: StringMorph) ifTrue: [ m color: textColor]].	! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'mt 8/28/2015 10:40'!
borderStyleMenu
	"Add border-style menu items"

	|  aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	
	aMenu addStayUpItemSpecial.
	aMenu add: 'border color...' translated target: self selector:#changeColor: argument: button.
	aMenu addLine.
	BorderStyle borderStyleChoices do:
		[:sym | (aMenu borderStyleForSymbol: sym)
			ifNotNil:
				[aMenu add: sym translated target: self selector: #setBorderStyle: argument: sym]].
	^aMenu popUpInWorld
! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'kfr 1/3/2016 18:04'!
changeColor: aButton
	NewColorPickerMorph useIt
		ifTrue:
			[ (NewColorPickerMorph
				on: self
				originalColor: aButton color
				setColorSelector: #setButtonColor:) openNear: aButton fullBoundsInWorld ]
		ifFalse:
			[ ColorPickerMorph new
				 choseModalityFromPreference ;
				 sourceHand: aButton activeHand ;
				 target: self ;
				 selector: #setButtonColor: ;
				 originalColor: aButton color ;
				
				putUpFor: aButton
				near: aButton fullBoundsInWorld ]	! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'mt 8/28/2015 10:28'!
colorMenuButton
	| selector name |
	name := self preference name.
	(name includesSubstring: 'border' caseSensitive: false)
				ifTrue: [ selector := #borderStyleMenu]
				ifFalse:[ selector := #fillStyleMenu].
	button := SimpleButtonMorph new
	label: self preference preferenceValue asString;
	actionSelector: selector;
	target: self.
	name = #menuBorderColor
		ifTrue:[ ^button borderColor: MenuMorph menuBorderColor; borderWidth: MenuMorph menuBorderWidth].
	name = #menuTitleBorderColor
		ifTrue:[ ^button borderColor: MenuMorph menuTitleBorderColor; borderWidth: MenuMorph menuTitleBorderWidth].
	self adjustLabelColor.
	^button color: self preference preferenceValue
	
	
	"UpdatingRectangleMorph new
		target: self preference;
		getSelector: #preferenceValue;
		putSelector: #preferenceValue:;
		extent: 22@22;
		setBalloonText: 'click here to change the color' translated;
		yourself."! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/6/2004 21:24'!
colorSwatch
	^UpdatingRectangleMorph new
		target: self preference;
		getSelector: #preferenceValue;
		putSelector: #preferenceValue:;
		extent: 22@22;
		setBalloonText: 'click here to change the color' translated;
		yourself.! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'mt 8/28/2015 10:40'!
fillStyleMenu
	"Add the items for changing the current fill style of the Morph"
	|  aMenu |
	"self canHaveFillStyles ifFalse:[^aMenu add: 'change color...' translated target: self action: #changeColor]."
	aMenu := MenuMorph new defaultTarget: self.
	"self preference preferenceValue addFillStyleMenuItems: aMenu hand: nil from: self."
	aMenu add: 'change color...' translated target: self selector:#changeColor: argument: button.
	aMenu addLine.
	aMenu add: 'solid fill' translated action: #useSolidFill.
	"aMenu add: 'gradient fill' translated action: #useGradientFill.
	aMenu add: 'bitmap fill' translated action: #useBitmapFill.
	aMenu add: 'default fill' translated action: #useDefaultFill."
	^aMenu popUpInWorld
	! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:00'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: self morphForName;
		addMorphBack: self horizontalFiller;
		addMorphBack: self colorMenuButton;
		yourself! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'kfr 5/6/2015 18:37'!
setBorderStyle: aBorderStyle
	self preference name = #menuBorderColor
						ifTrue: [button color: MenuMorph menuColor;
							borderWidth: MenuMorph menuBorderWidth].
	self preference name = #menuTitleBorderColor
						ifTrue: [button color: MenuMorph menuTitleColor;
							borderWidth: MenuMorph menuTitleBorderWidth].					
	self preference preferenceValue: aBorderStyle.
	button label: self preference preferenceValue asString;
	borderColor: aBorderStyle.
	! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'kfr 1/3/2016 18:08'!
setButtonColor: aColor
	button color: aColor.
	self preference preferenceValue: aColor.
	button label: self preference preferenceValue asString.
	self adjustLabelColor
! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'kfr 5/6/2015 18:48'!
useSolidFill
	"Make receiver use a solid fill style (e.g., a simple color)"
	self preference preferenceValue isSolidFill ifTrue:[^self]. "Already done"
	self preference preferenceValue: self preference preferenceValue asColor. "Try minimizing changes"
	
	button label: self preference preferenceValue asString;
	color: self preference preferenceValue
	! !

PBPreferenceView subclass: #PBHaloThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBHaloThemePreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the button for the Halo Theme preference!

!PBHaloThemePreferenceView class methodsFor: 'class initialization' stamp: 'hpt 9/26/2004 15:48'!
initialize
	PreferenceViewRegistry ofHaloThemePreferences register: self.! !

!PBHaloThemePreferenceView class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 16:33'!
unload
	"Unload order is not guaranteed so guard against failure"
	[PreferenceViewRegistry ofHaloThemePreferences unregister: self] on: Error do:[]! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'nice 12/26/2009 19:01'!
haloThemeRadioButtons
	"Answer a column of butons representing the choices of halo theme"

	| buttonColumn |
	buttonColumn := self verticalPanel.
	#(	(iconicHaloSpecifications iconic iconicHalosInForce	'circular halos with icons inside')
		(classicHaloSpecs	classic	classicHalosInForce		'plain circular halos')
		(simpleFullHaloSpecifications		simple	simpleHalosInForce	'fewer, larger halos')
		(customHaloSpecs	custom	customHalosInForce		'customizable halos')) do:

		[:quad |
			| aRow aRadioButton aLabel |
			aRadioButton := UpdatingThreePhaseButtonMorph radioButton
				target: Preferences;
				setBalloonText: quad fourth;
				actionSelector: #installHaloTheme:;
				getSelector: quad third;
				arguments: (Array with: quad first);
				yourself.
			aLabel := (StringMorph contents: quad second asString)
						setBalloonText: quad fourth;
						yourself.
			aRow := self horizontalPanel
				cellInset: 4;
				addMorphBack: aRadioButton;
				addMorphBack: aLabel.
			buttonColumn addMorphBack: aRow].
	^ buttonColumn

	"(Preferences preferenceAt: #haloTheme) view tearOffButton"! !

!PBHaloThemePreferenceView methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:12'!
initialize
	self addActionTitled: 'edit custom halos' 
		target: Preferences 
		selector:  #editCustomHalos 
		arguments: {} 
		balloonText: 'Click here to edit the method that defines the custom halos' translated.! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:00'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	| innerPanel |
	innerPanel := self horizontalPanel
		addMorphBack: (self blankSpaceOf: 10@0);
		addMorphBack: self haloThemeRadioButtons;
		yourself.
	^self verticalPanel
		color: aColor;
		layoutInset: 2;
		addMorphBack: self morphForName;
		addMorphBack: innerPanel.! !

PBPreferenceView subclass: #PBNumericPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBNumericPreferenceView class methodsFor: 'class initialization' stamp: 'hpt 12/9/2004 22:21'!
initialize
	PreferenceViewRegistry ofNumericPreferences register: self.! !

!PBNumericPreferenceView class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 16:33'!
unload
	"Unload order is not guaranteed so guard against failure"
	[PreferenceViewRegistry ofNumericPreferences unregister: self] on: Error do:[].! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/9/2004 22:23'!
preferenceValue
	^self preference preferenceValue asString! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:53'!
preferenceValue: aTextOrString
	(aTextOrString notEmpty and: [aTextOrString asString isAllDigits])
		ifFalse: [^false].
	self preference preferenceValue: aTextOrString asNumber.
	^true.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:00'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: self morphForName;
		addMorphBack: self horizontalFiller;
		addMorphBack: self textField;
		yourself.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:08'!
textField
	^(PluggableTextMorph
		on: self
		text: #preferenceValue
		accept: #preferenceValue:)
			hideScrollBarsIndefinitely;
			acceptOnCR: true;
			vResizing: #rigid;
			hResizing: #spaceFill;
			height: TextStyle defaultFont height + 6;
			yourself.! !

!PBPreferenceView class methodsFor: 'view registry' stamp: 'hpt 9/26/2004 16:09'!
handlesPanel: aPreferencePanel
	^aPreferencePanel isKindOf: PreferenceBrowser! !

!PBPreferenceView methodsFor: 'actions' stamp: 'stephaneducasse 2/4/2006 20:39'!
actions
	^actions ifNil: [actions := OrderedCollection new.]! !

!PBPreferenceView methodsFor: 'actions' stamp: 'hpt 12/8/2004 18:13'!
addActionTitled: aTitle target: aTarget selector: aSelector arguments: aCollection balloonText: aText
	self actions add: { aTitle. aTarget. aSelector. aCollection. aText }! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:42'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:15'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:13'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'bf 3/4/2010 12:14'!
offerPreferenceNameMenu: aPreferenceBrowser
	"the user clicked on a preference name -- put up a menu"

	| aMenu |			
	aMenu := MenuMorph new 
		defaultTarget: self preference;
		addTitle: self preference name.

	(Preferences okayToChangeProjectLocalnessOf: self preference name) ifTrue:
		[aMenu addUpdating: #isProjectLocalString target: self preference action: #toggleProjectLocalness.
		aMenu balloonTextForLastItem: 'Some preferences are best applied uniformly to all projects, and others are best set by each individual project.  If this item is checked, then this preference will be printed in bold and will have a separate value for each project'].

	aMenu add: 'browse senders' translated target: self systemNavigation selector: #browseAllSelect:name:autoSelect: argumentList: {[:m | self preference selectors anySatisfy: [:sel | m hasLiteralThorough: sel]]. 'Preference senders: {1}' translated format: {self preference name}. self preference selectors first}.
	aMenu balloonTextForLastItem: 'This will open a method-list browser on all methods that the send the preference "', self preference name, '".'. 
	aMenu add: 'show category...' target: aPreferenceBrowser selector: #findCategoryFromPreference: argument: self preference name.
	aMenu balloonTextForLastItem: 'Allows you to find out which category, or categories, this preference belongs to.'.

	Smalltalk isMorphic ifTrue:
		[aMenu add: 'hand me a button for this preference' target: self selector: #tearOffButton.
		aMenu balloonTextForLastItem: 'Will give you a button that governs this preference, which you may deposit wherever you wish'].

	aMenu add: 'copy this name to clipboard' target: self preference selector: #copyName.
	aMenu balloonTextForLastItem: 'Copy the name of the preference to the text clipboard, so that you can paste into code somewhere'.

	aMenu popUpInWorld! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

PBPreferenceView subclass: #PBTextPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBTextPreferenceView class methodsFor: 'class initialization' stamp: 'hpt 9/26/2004 17:01'!
initialize
	PreferenceViewRegistry ofTextPreferences register: self.! !

!PBTextPreferenceView class methodsFor: 'class initialization' stamp: 'ar 1/2/2010 16:33'!
unload
	"Unload order is not guaranteed so guard against failure"
	[PreferenceViewRegistry ofTextPreferences unregister: self] on: Error do:[]! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:46'!
preferenceValue
	^self preference preferenceValue ifNil: ['']! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:38'!
preferenceValue: aTextOrString
	self preference preferenceValue: aTextOrString asString.
	^true.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:00'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: self morphForName;
		addMorphBack: self textField;
		yourself.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'mt 4/19/2015 09:07'!
textField
	^(PluggableTextMorph
		on: self
		text: #preferenceValue
		accept: #preferenceValue:)
			hideScrollBarsIndefinitely;
			borderColor: #inset;
			acceptOnCR: true;
			color: Color gray veryMuchLighter;
			vResizing: #rigid;
			hResizing: #spaceFill;
			height: TextStyle defaultFont height + 6;
			yourself.! !

!PreferenceView class methodsFor: 'view registry' stamp: 'hpt 9/26/2004 16:09'!
handlesPanel: aPreferencePanel
	self subclassResponsibility ! !

!PreferenceView class methodsFor: 'instance creation' stamp: 'hpt 9/24/2004 22:25'!
preference: aPreference
	^self new
		initializeWithPreference: aPreference;
		yourself! !

!PreferenceView methodsFor: 'initialization' stamp: 'hpt 9/24/2004 22:25'!
initializeWithPreference: aPreference
	preference := aPreference! !

!PreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 17:01'!
morphForName

	^ ((StringMorph contents: self preference name)
			color: ((UserInterfaceTheme current get: #textColor for: PluggableListMorph) ifNil: [Color black]);
			font: ((UserInterfaceTheme current get: #font for: PluggableListMorph) ifNil: [TextStyle defaultFont]);
			yourself)! !

!PreferenceView methodsFor: 'accessing' stamp: 'hpt 9/24/2004 22:25'!
preference
	^preference! !

!PreferenceView methodsFor: 'user interface' stamp: 'hpt 9/24/2004 22:56'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	self subclassResponsibility ! !

!PreferenceView methodsFor: 'user interface' stamp: 'mt 8/1/2016 16:55'!
tearOffButton
	"Hand the user a button the can control this"

	| aButton |
	aButton := self representativeButtonWithColor: ((UserInterfaceTheme current get: #uniformWindowColor for: Model) ifNil: [Color white]) inPanel: nil.
	aButton borderWidth: 1; borderColor:  Color black; useRoundedCorners.
	aButton openInHand! !

Object subclass: #PreferenceViewRegistry
	instanceVariableNames: 'registeredClasses viewOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

PreferenceViewRegistry class
	instanceVariableNames: 'registries'!

!PreferenceViewRegistry commentStamp: '<historical>' prior: 0!
PreferenceViewRegistry is much like the AppRegistry classes.  Its purpose is to allow PreferenceBrowser implementers to register its own views for each kind of preference.!

PreferenceViewRegistry class
	instanceVariableNames: 'registries'!

!PreferenceViewRegistry class methodsFor: 'accessing' stamp: 'ar 8/25/2009 19:38'!
forType: typeName
	"Answer the preference registry for the given type name"
	^typeName caseOf:{
		[#Boolean]	->	[self ofBooleanPreferences].
		[#Color]	->	[self ofColorPreferences].
		[#Font]		->	[self ofFontPreferences].
		[#Number]	->	[self ofNumericPreferences].
		[#String]	->	[self ofTextPreferences].
		[#Halo]		->	[self ofHaloThemePreferences].
		[#WindowColor]	-> [self registryOf: #windowColorPreferences]
	} otherwise:[self registryOf: typeName].! !

!PreferenceViewRegistry class methodsFor: 'class initialization' stamp: 'ar 8/9/2009 16:40'!
initialize
	"Ensure we aren't carrying obsolete references"
	self removeObsolete.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofBooleanPreferences
	^(self registryOf: #booleanPreferences)
		viewOrder: 1; 
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:24'!
ofColorPreferences
	^(self registryOf: #colorPreferences)
		viewOrder: 5;
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:24'!
ofFontPreferences
	^(self registryOf: #fontPreferences)
		viewOrder: 4;
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofHaloThemePreferences
	^(self registryOf: #haloThemePreferences)
		viewOrder: 2;
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 12/9/2004 22:16'!
ofNumericPreferences
	^(self registryOf: #numericPreferences)
		viewOrder: 3;
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofTextPreferences
	^(self registryOf: #textPreferences)
		viewOrder: 3;
		yourself.! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 15:28'!
registries
	^registries ifNil: [registries := Dictionary new]! !

!PreferenceViewRegistry class methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 15:33'!
registryOf: aSymbol
	^self registries at: aSymbol ifAbsentPut: [self new]! !

!PreferenceViewRegistry class methodsFor: 'class initialization' stamp: 'ar 8/9/2009 16:42'!
removeObsolete
	"PreferenceViewRegistry removeObsolete"
	"Remove obsolete entries from the registries"
	self registries do:[:viewRegistry|
		viewRegistry registeredClasses copy do:[:rClass|
			rClass isObsolete ifTrue:[viewRegistry unregister: rClass]]].! !

!PreferenceViewRegistry class methodsFor: 'accessing' stamp: 'ar 8/25/2009 19:38'!
typeOfRegistry: aRegistry
	"Answer the type name for a particular view registry"
	^aRegistry caseOf:{
		[self ofBooleanPreferences]	-> [#Boolean].
		[self ofColorPreferences]		-> [#Color].
		[self ofFontPreferences]		-> [#Font].
		[self ofNumericPreferences]	-> [#Number].
		[self ofTextPreferences]		-> [#String].
		[self ofHaloThemePreferences]	-> [#Halo].
		[self registryOf: #windowColorPreferences]	-> [#WindowColor].
	} otherwise:[self registries keyAtIdentityValue: aRegistry ifAbsent:[nil]].! !

!PreferenceViewRegistry methodsFor: 'initialize-release' stamp: 'hpt 9/26/2004 16:22'!
initialize
	viewOrder := 1.! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
registeredClasses
	^registeredClasses ifNil: [registeredClasses := OrderedCollection new]! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
register: aProviderClass
	(self registeredClasses includes: aProviderClass) 
		ifFalse: [self registeredClasses add: aProviderClass].! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
unregister: aProviderClass
	self registeredClasses remove: aProviderClass ifAbsent: []! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
viewClassFor: aPreferencePanel
	^self registeredClasses 
		detect: [:aViewClass| aViewClass handlesPanel: aPreferencePanel]
		ifNone: [].! !

!PreferenceViewRegistry methodsFor: 'view order' stamp: 'hpt 9/26/2004 16:22'!
viewOrder
	"answer the order in which the registered views should appear relative to the other views"
	^viewOrder! !

!PreferenceViewRegistry methodsFor: 'view order' stamp: 'hpt 9/26/2004 16:22'!
viewOrder: aNumber
	viewOrder := aNumber! !

Model subclass: #PreferenceBrowser
	instanceVariableNames: 'selectedCategoryIndex selectedPreference searchPattern searchResults lastExecutedSearch preferences title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'mt 7/3/2016 10:08'!
initialize
	self
		registerInOpenMenu;
		registerInFlaps! !

!PreferenceBrowser class methodsFor: 'instance creation' stamp: 'stephaneducasse 2/4/2006 20:39'!
open
	| browser |
	browser := self new.
	(PreferenceBrowserMorph withModel: browser)
		openInWorld.
	^browser.	! !

!PreferenceBrowser class methodsFor: 'instance creation' stamp: 'hpt 9/19/2004 12:51'!
prototypicalToolWindow
	| window |
	window := PreferenceBrowserMorph withModel: self new.
	window applyModelExtent.
	^window! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:48'!
registerInFlaps
	Flaps 
		registerQuad: 
			{ #PreferenceBrowser. 
			#prototypicalToolWindow.
			'Preference Browser' translated.
			'A tool for expressing personal preferences for numerous options' translated }
	 	forFlapNamed: 'Tools' translated.
	Flaps replaceToolsFlap! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:40'!
registerInOpenMenu
	(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: [
		TheWorldMenu unregisterOpenCommand: 'Preference Browser'.
		TheWorldMenu registerOpenCommand: {'Preference Browser'. {self. #open}}].
		! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:45'!
unload
	self 
		unregisterFromOpenMenu;
		unregisterFromFlaps.! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:47'!
unregisterFromFlaps
	Flaps 
		unregisterQuadsWithReceiver: self;
		replaceToolsFlap! !

!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'hpt 9/19/2004 12:44'!
unregisterFromOpenMenu
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
		ifTrue: [TheWorldMenu unregisterOpenCommand: 'Preference Browser'].
! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
allCategoryLabel
	^'-- all --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 17:59'!
allCategorySelected
	^self selectedCategory = self allCategoryLabel! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'mt 8/27/2015 10:42'!
allPreferences
	^ preferences allPreferences  asSortedCollection:
			[:pref1 :pref2 | 
			pref1 viewRegistry viewOrder  <pref2 viewRegistry viewOrder  or:
					[pref1 viewRegistry viewOrder  =pref2 viewRegistry viewOrder 
						 &(pref1 name  <pref2 name)]]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'mt 8/27/2015 10:38'!
categoryList
	^OrderedCollection new
		add:  self allCategoryLabel;
		addAll: preferences categoryList asSortedCollection;
		add: self searchResultsCategoryLabel;
		yourself.
	
	! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'mt 8/5/2016 10:07'!
defaultSelected

	(UIManager default
		confirm: 'Do you really want to restorethe default\preferences?\\If you want to keep the current state,\you have to save it first.' translated withCRs
		title: 'Restore Preferences') ifFalse: [^ self].


	Preferences chooseInitialSettings! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.671 g: 0.9 b: 0.9)! !

!PreferenceBrowser methodsFor: 'find' stamp: 'mt 8/27/2015 09:08'!
findCategoryFromPreference: prefSymbol
	"Find all categories in which the preference occurs"

	| aMenu| 
	aMenu := MenuMorph new defaultTarget: self.
	(preferences categoryListOfPreference: prefSymbol) do:
		[:aCategory | aMenu add: aCategory target: self selector: #selectedCategory: argument: aCategory].
	aMenu popUpInWorld! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 13:18'!
helpSelected 
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: self helpText;
		openLabel: self windowTitle.! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 13:42'!
helpText
	^(String streamContents: [:str |
		str nextPutAll:
'Many aspects of the system are goberned by the settings of various ''Preferences''.

Click on any of the categories shown at the left list to see all the preferences in that category. Or type into the search box at the bottom of the window, then hit Search, and all Preferences matching whatever you typed in will appear in the ''search results'' category. A preference is considered to match your search if either its name matches the text *or* if anything in the preference''s help text does.

To find out more about any particular Preference just select it and its help text will appear.

Some preferences can be ''local'' instead of global. When a preference is set as global its value will apply to whatever project you are in. A local preference will only be valid in the project that you set it in.

The ''Save'' button allow you to quickly save your current settings so it can later be restored with the ''Load'' button.

To carry your settings to another Squeak you might want to use the ''Save to disk'' and ''Load from disk'' buttons. The save to disk option will store all your settings in a ''my.prefs'' file in your Squeak''s current directory.

Lastly, you can use the "theme..." button to set multiple preferences all at once; click on the "theme..." button and try the themes already provided with your Squeak image.']) translated! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'bf 4/12/2011 12:17'!
initialExtent
	^ 660@440! !

!PreferenceBrowser methodsFor: 'initialize-release' stamp: 'rr 10/1/2005 15:25'!
initialize
	preferences := Preferences.
	title := 'Preference Browser'.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:35'!
lastExecutedSearch
	^lastExecutedSearch! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
lastExecutedSearch: aTextOrString
	^lastExecutedSearch:= aTextOrString! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'mt 8/5/2016 10:19'!
loadFromDiskSelected 

	(UIManager default
		confirm: 'Do you really want to restore your\personal preferences from disk?\\The file ''my.prefs'' will be loaded.' translated withCRs
		title: 'Restore Preferences from Disk') ifFalse: [^ self].

	preferences restorePreferencesFromDisk! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'mt 8/5/2016 10:05'!
loadSelected

	(UIManager default
		confirm: 'Do you really want to restore\your personal preferences?' translated withCRs
		title: 'Restore Preferences') ifFalse: [^ self].
		
	preferences restorePersonalPreferences.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
nonSpecialCategorySelected
	^self allCategorySelected not & self searchResultsCategorySelected not! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/11/2005 17:14'!
preferences
	^ preferences! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'mt 8/27/2015 10:44'!
preferencesInCategory: aCategory
	^(preferences preferencesInCategory: aCategory) asSortedCollection:
		[:pref1 :pref2 | 
				pref1 viewRegistry viewOrder  <pref2 viewRegistry viewOrder  or:
						[pref1 viewRegistry viewOrder  =pref2 viewRegistry viewOrder 
							 &(pref1 name  <pref2 name)]]! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'cmm 2/13/2010 20:08'!
representsSameBrowseeAs: anotherModel
	"If an existing Preference browser is on-screen, use it."
	^ self class = anotherModel class! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'mt 8/5/2016 10:05'!
saveSelected

	(UIManager default
		confirm: 'Do you really want to overwrite\your personal preferences?' translated withCRs
		title: 'Save Preferences') ifFalse: [^ self].

	preferences savePersonalPreferences.! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'mt 8/5/2016 10:18'!
saveToDiskSelected 

	(UIManager default
		confirm: 'Do you really want to overwrite your\personal preferences on disk?\\The file ''my.prefs'' will be updated.' translated withCRs
		title: 'Save Preferences to Disk') ifFalse: [^ self].
		
	preferences storePreferencesToDisk! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 7/8/2006 17:50'!
searchFieldLegend
	^''.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:39'!
searchPattern
	^searchPattern ifNil: [searchPattern := self searchFieldLegend]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'kb 11/12/2009 14:51'!
searchPatternNeverTriggered

	^self searchPattern! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchPattern: aStringOrText
	aStringOrText 
		ifEmpty: [searchPattern := self searchFieldLegend]
		ifNotEmpty: [searchPattern := aStringOrText asString].
	self changed: #searchPattern.
	^true! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 23:36'!
searchPreferencesFor: pattern
	| result |
	result := pattern asString asLowercase withBlanksTrimmed.
	result ifEmpty: [^self].
	searchResults := self allPreferences select: [:aPreference |
		(aPreference name includesSubstring: result caseSensitive: false) or:
				[aPreference helpString includesSubstring: result caseSensitive: false]].		
	self selectSearchResultsCategory.
	self lastExecutedSearch: pattern.
! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchResults
	^searchResults ifNil: [searchResults := #()]! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
searchResultsCategoryLabel
	^'-- search results --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
searchResultsCategorySelected
	^self selectedCategory = self searchResultsCategoryLabel! !

!PreferenceBrowser methodsFor: 'buttons callbacks' stamp: 'hpt 9/19/2004 03:21'!
searchSelected
	self searchPreferencesFor: self searchPattern.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:01'!
selectedCategory
	^self categoryList at: selectedCategoryIndex ifAbsent: []! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:49'!
selectedCategoryIndex
	^selectedCategoryIndex ifNil: [selectedCategoryIndex := 0].! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:45'!
selectedCategoryIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: nil.
	selectedCategoryIndex := anIndex.
	self changed: #selectedCategoryIndex.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:27'!
selectedCategoryPreferences
	self allCategorySelected
		ifTrue: [^self allPreferences].
	self searchResultsCategorySelected 
		ifTrue: [^self searchResults].
	^self preferencesInCategory: self selectedCategory.
	! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/25/2004 17:09'!
selectedCategory: aCategorySymbol
	self selectedCategoryIndex: (self categoryList indexOf: aCategorySymbol ifAbsent: [0]).! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:53'!
selectedPreference
	^selectedPreference! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:22'!
selectedPreferenceHelpText
	self selectedPreference
		ifNil: [^''].
	^self selectedPreference helpString withBlanksTrimmed.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 21:17'!
selectedPreferenceIndex
	^self selectedCategoryPreferences indexOf: self selectedPreference ifAbsent: [0]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:41'!
selectedPreferenceIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: (self selectedCategoryPreferences at: anIndex).! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:39'!
selectedPreference: aPreference
	selectedPreference := aPreference.
	self changed: #selectedPreference.
	self changed: #selectedPreferenceIndex.
	self changed: #selectedPreferenceHelpText.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
selectFirstPreferenceOrNil
	| prefs |
	self selectedCategory
		ifNil: [^self selectedPreference: nil].
	prefs := self preferencesInCategory: self selectedCategory.
	prefs isEmpty
		ifTrue: [^self selectedPreference: nil].
	self selectedPreference: prefs first.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:23'!
selectSearchResultsCategory
	self selectedCategoryIndex: (self categoryList indexOf: self searchResultsCategoryLabel)! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:35'!
stepAt: millisecondClockValue in: aWindow
	super stepAt: millisecondClockValue in: aWindow.
	self searchPattern ~= self lastExecutedSearch
		ifTrue: [self searchPreferencesFor: self searchPattern].! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:06'!
themeSelected 
	preferences offerThemesMenu! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:41'!
wantsStepsIn: aWindow
	^true.! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'rr 1/8/2006 12:35'!
windowTitle
	^ title translated! !

Morph subclass: #PBPreferenceButtonMorph
	instanceVariableNames: 'moreButton model preference preferenceMorphicView preferenceView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PBPreferenceButtonMorph class methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:20'!
preference: aPreference
	^self preference: aPreference model: nil! !

!PBPreferenceButtonMorph class methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:19'!
preference: aPreference model: aModel
	^self new
		initializeWithPreference: aPreference model: aModel;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:15'!
actionButtons
	^self preferenceView actions collect: [:aTuple |
		self basicButton
				label: aTuple first;
				target: aTuple second;
				actionSelector: aTuple third;
				arguments: aTuple fourth;
				setBalloonText: aTuple fifth ]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 8/24/2005 20:33'!
addExtraControls
	| m |
	m := self horizontalPanel
		cellInset: 3;
		addAllMorphs: self actionButtons;
		addMorphBack: self horizontalFiller;
		addMorphBack: self moreButton;
		yourself.
	self 
		addMorphBack: (self blankSpaceOf: 2@2);
		addMorphBack: self preferenceHelpTextMorph;
		fullBounds; "to force a layout compute needed by the textMorphs's autoFit"
		addMorphBack: m
! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 17:16'!
advancedOptionsSelected
	self preferenceView offerPreferenceNameMenu: self model! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 17:06'!
basicButton
	| button |
	button := SimpleButtonMorph new.
	button
		borderWidth: 1;
		borderColor: self paneColor;
		on: #mouseEnter send: #value to: [button borderWidth: 2];
		on: #mouseLeave send: #value to: [button borderWidth: 1];
		vResizing: #rigid;
		height: (TextStyle defaultFont height + 4);
		useSquareCorners;
		clipSubmorphs: true;
		color: self paneColor muchLighter;
		target: self.
	^button! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:59'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 0;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:29'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:43'!
caseInsensitiveBeginsWith: prefix in: string
	^(string findString: prefix startingAt: 1 caseSensitive: false) = 1! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'mt 8/1/2016 17:06'!
highlightOff
	self beTransparent.
	self label
		color: ((UserInterfaceTheme current get: #textColor for: PluggableListMorph) ifNil: [Color black]);
		font: ((UserInterfaceTheme current get: #font for: PluggableListMorph) ifNil: [TextStyle defaultFont]).
	self removeExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'mt 8/1/2016 17:07'!
highlightOn
	
	self color: ((UserInterfaceTheme current get: #selectionColor for: PluggableListMorph) ifNil: [Color gray alpha: 0.1]).

	self label
		color: ((UserInterfaceTheme current get: #selectionTextColor for: PluggableListMorph) ifNil: [Color black]);
		font: ((UserInterfaceTheme current get: #font for: PluggableListMorph) ifNil: [TextStyle defaultFont]).
		
	self addExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeLayout
	self layoutPolicy: TableLayout new;
		beTransparent;
		layoutInset: 0;
		cellInset: 0;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.		! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeWithPreference: aPreference model: aModel
	preference := aPreference.
	model := aModel.
	self initializeLayout.
	self addMorphBack: self preferenceMorphicView.
	self highlightOff.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:42'!
label
	^self preferenceMorphicView firstSubmorph! !

!PBPreferenceButtonMorph methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:34'!
model
	^model! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:17'!
moreButton
	^moreButton ifNil: 
		[moreButton := self basicButton 
						label: 'more' translated; 
						setBalloonText: 
							'Click here for advanced options'translated;
						actionSelector: #advancedOptionsSelected]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'stephaneducasse 2/4/2006 20:39'!
paneColor
	| browser |
	browser := (self ownerChain 
		detect: [:ea | ea isKindOf: PreferenceBrowserMorph] 
		ifNone: [^Color black]) .
	^browser paneColor! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:13'!
preference
	^preference! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:56'!
preferenceHelp
	| help name |
	help := self preference helpString withBlanksTrimmed.
	name := self preference name.
	(self caseInsensitiveBeginsWith: name  in: help)
		ifTrue: [help := help allButFirst: name size].
	(help notEmpty and: [help first = $:])
		ifTrue: [help := help allButFirst].
	^help withBlanksTrimmed.
! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'mt 8/1/2016 17:03'!
preferenceHelpText
	^self preferenceHelp asText
		addAttribute: TextEmphasis italic;
		addAttribute: (TextColor color: ((UserInterfaceTheme current get: #textColor for: PluggableListMorph) ifNil: [Color black]));
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceHelpTextMorph
	| text tm |
	text := self preferenceHelpText.
	tm := TextMorph new
		contents: text;
		wrapOnOff;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		lock: true;
		visible: text notEmpty;
		yourself. "we don't want an empty textmorph showing"
	tm isAutoFit
		ifFalse: [tm autoFitOnOff].
	^tm.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:48'!
preferenceMorphicView
	^preferenceMorphicView
		ifNil: 
			[preferenceMorphicView := self preferenceView
				representativeButtonWithColor: Color transparent inPanel: self model.
			preferenceMorphicView hResizing: #spaceFill.
			^preferenceMorphicView]! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceView
	^preferenceView
		ifNil: [preferenceView := self preference viewForPanel: self model.]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 16:40'!
removeExtraControls
	self submorphs copyWithoutFirst do: [:ea | ea delete]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:27'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

!Preference methodsFor: '*PreferenceBrowser' stamp: 'hpt 9/26/2004 16:58'!
representativeButtonWithColor: aColor inPanel: aPanel
	| view |
	view := self viewForPanel: aPanel.
	^view ifNotNil: [view representativeButtonWithColor: aColor inPanel: aPanel]! !

!Preference methodsFor: '*PreferenceBrowser' stamp: 'bf 3/4/2010 11:46'!
selectors
	"for browsing senders"
	^{name}! !

!Preference methodsFor: '*PreferenceBrowser' stamp: 'hpt 9/26/2004 15:42'!
viewClassForPanel: aPreferencePanel
	^self viewRegistry viewClassFor: aPreferencePanel! !

!Preference methodsFor: '*PreferenceBrowser' stamp: 'hpt 9/26/2004 16:58'!
viewForPanel: aPreferencePanel
	| viewClass |
	viewClass := self viewClassForPanel: aPreferencePanel.
	^viewClass ifNotNil: [viewClass preference: self]! !

!Preference methodsFor: '*PreferenceBrowser' stamp: 'ar 8/9/2009 15:21'!
viewRegistry
	^PreferenceViewRegistry forType: self type! !

!Preferences class methodsFor: '*PreferenceBrowser' stamp: 'ar 8/9/2009 16:12'!
addPreference: aName categories: categoryList default: aValue balloonHelp: helpString projectLocal: localBoolean changeInformee: informeeSymbol changeSelector: aChangeSelector viewRegistry: aViewRegistry
	"For compatibility with the old set of protocols"
	^self addPreference: aName categories: categoryList default: aValue balloonHelp: helpString projectLocal: localBoolean changeInformee: informeeSymbol changeSelector: aChangeSelector type: (PreferenceViewRegistry typeOfRegistry: aViewRegistry).! !

SystemWindow subclass: #PreferenceBrowserMorph
	instanceVariableNames: 'mainPanel defaultButton saveButton loadButton saveToDiskButton loadFromDiskButton themeButton helpButton preferenceList lastKeystrokeTime lastKeystrokes highlightedPreferenceButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PreferenceBrowser'!

!PreferenceBrowserMorph class methodsFor: 'instance creation' stamp: 'hpt 9/18/2004 15:31'!
withModel: aPreferenceBrowser
	^self new initializeWithModel: aPreferenceBrowser;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/20/2004 23:31'!
adjustPreferenceListItemsWidth
	| panel |
	self preferenceList scroller submorphs 
		ifEmpty: [^self].
	panel := self preferenceListInnerPanel. 
	panel width: self preferenceList width - (self preferenceList scrollBarThickness*2).
	panel submorphsDo: [:ea | ea hResizing: #rigid; width: panel width].
	self preferenceList setScrollDeltas.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:53'!
basicButton

	^ PluggableButtonMorph new
		model: self model;
		offColor: self paneColor;
		hResizing: #shrinkWrap;
		layoutInset: (15@5 corner: 15@5);
		yourself! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:12'!
basicKeyPressed: anEvent
	| aChar oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionPref |
	aChar := anEvent keyCharacter.
	nextSelection := oldSelection := self selectedPreferenceIndex.
	max := self selectedCategoryPreferences size.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self selectedCategoryPreferences copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self selectedCategoryPreferences copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionPref := nextSelectionList detect: [:a | a name withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self preferenceList flash"match not found"].
	nextSelection := self selectedCategoryPreferences findFirst: [:a | a  = nextSelectionPref].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self preferenceList flash].
	^ self selectedPreferenceIndex: nextSelection! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 8/28/2005 00:04'!
buttonRowLayoutFrame 
	^LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@ (TextStyle defaultFont height * 2.5))! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:47'!
defaultButton
	^defaultButton ifNil: 
		[defaultButton := self basicButton 
						label: 'default' translated; 
						action: #defaultSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their standard ',
							'default values.' translated]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
downKeyPressed: anEvent
	self selectedPreferenceIndex:
		(self selectedPreferenceIndex + 1 
				min: self selectedCategoryPreferences size)! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:17'!
endKeyPressed: anEvent
	self selectedPreferenceIndex: self selectedCategoryPreferences size.
! !

!PreferenceBrowserMorph methodsFor: 'geometry' stamp: 'hpt 9/18/2004 21:05'!
extent: aPoint
	super extent: aPoint.
	self fullBounds.
	self adjustPreferenceListItemsWidth.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:48'!
helpButton
	^helpButton ifNil: 
		[helpButton := self basicButton 
						label: 'help' translated; 
						setBalloonText: 
							'Click here to get some hints on use of this Preferences ',
							'Panel' translated;
						action: #helpSelected]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
homeKeyPressed: anEvent
	self selectedPreferenceIndex: 1.
! !

!PreferenceBrowserMorph methodsFor: 'initialization' stamp: 'mt 4/15/2015 07:11'!
initializeWithModel: aPreferenceBrowser
	lastKeystrokeTime := 0.
	lastKeystrokes := ''.
	self 
		model: aPreferenceBrowser;
		setLabel: self model windowTitle;
		name: 'PreferenceBrowser';
		addMorph: self rootPanel fullFrame: self rootPanelLayoutFrame;
		addMorph: self newButtonRow fullFrame: self buttonRowLayoutFrame.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:19'!
keyPressed: anEvent
	self selectedCategory 
		ifNil: [^self].
	anEvent keyValue = 30
		ifTrue: [^self upKeyPressed: anEvent].
	anEvent keyValue = 31
		ifTrue: [^self downKeyPressed: anEvent].
	anEvent keyValue = 1 
		ifTrue: [^self homeKeyPressed: anEvent].
	anEvent keyValue = 4
		ifTrue: [^self endKeyPressed: anEvent].
	anEvent keyValue = 11
		ifTrue: [^self pageUpKeyPressed: anEvent].
	anEvent keyValue = 12
		ifTrue: [^self pageDownKeyPressed: anEvent].
	self basicKeyPressed: anEvent.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:47'!
loadButton
	^loadButton ifNil: 
		[loadButton := self basicButton 
						label: 'load' translated; 
						action: #loadSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their values ',
							'in your Personal Preferences.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:48'!
loadFromDiskButton
	^loadFromDiskButton ifNil: 
		[loadFromDiskButton := self basicButton 
						label: 'load from disk' translated; 
						action: #loadFromDiskSelected;						
						setBalloonText: 
							'Click here to load all the preferences from ',
							'their saved values on disk.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - main panel' stamp: 'mt 4/15/2015 07:14'!
mainPanel
	^mainPanel ifNil: 
		[mainPanel := BorderedMorph new
			color: Color transparent;
			borderWidth: 0;
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			cellInset: 5;
			changeProportionalLayout;
			on: #mouseEnter send: #paneTransition: to: self;
			addMorphBack: self newCategoryList;
			addMorphBack: self preferenceList;
			layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@ 30 corner: 0@0));
			addPaneSplitters;
			yourself].! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/26/2004 23:01'!
mouseDownOn: aPreferenceView event: anEvent
	anEvent hand newKeyboardFocus: self preferenceList scroller.
	anEvent yellowButtonPressed
		ifTrue: [aPreferenceView offerPreferenceNameMenu: self model]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 4/14/2015 16:49'!
newButtonRow
	^BorderedMorph new
		color: Color transparent;
		borderWidth: 0;
		cellInset: 2;
		layoutInset: 2;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		on: #mouseEnter send: #paneTransition: to: self;
		on: #mouseLeave send: #paneTransition: to: self;
		addMorphBack: self defaultButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveButton;
		addMorphBack: self loadButton;
		addMorphBack: self newSeparator;
		addMorphBack: self saveToDiskButton;
		addMorphBack: self loadFromDiskButton;
		addMorphBack: self newSeparator;
		addMorphBack: self themeButton;
		addMorphBack: self newTransparentFiller;
		addMorphBack: self helpButton;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'mt 8/1/2016 15:57'!
newCategoryList 
	^(PluggableListMorph
		on: self model
		list: #categoryList
		selected: #selectedCategoryIndex
		changeSelected: #selectedCategoryIndex:)
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			layoutFrame: (LayoutFrame fractions: (0@0 corner: 0.25@1));
			yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 8/27/2005 23:44'!
newCategoryListPanel
	^Morph new
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 3;
		listCentering: #topLeft;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		clipSubmorphs: true;
		addMorphBack: self newCategoryListPanelLabel;
		addMorphBack: self newCategoryList! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/19/2004 02:29'!
newCategoryListPanelLabel 
	^StringMorph contents: 'Categories' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceButtonFor: aPreference 
	| button |
	button := PBPreferenceButtonMorph preference: aPreference model: self model.
	button 
		on: #mouseDown
		send: #value:
		to: 
			[:anEvent | 
			self
				selectedPreference: aPreference;
				mouseDownOn: button preferenceView event: anEvent].
	^button! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceListInnerPanel
	| panel maxWidth totalHeight |
	panel := (Morph new)
				color: Color transparent;
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				cellPositioning: #topLeft;
				yourself.
	self selectedCategoryPreferences 
		do: [:aPref | panel addMorphBack: (self newPreferenceButtonFor: aPref)].
	panel submorphs size = 0 ifTrue: [^panel].
	maxWidth := (panel submorphs detectMax: [:m | m width]) width.
	panel width: maxWidth.
	totalHeight := (panel submorphs collect: [:ea | ea height]) inject: 0
				into: [:h :tot | h + tot].
	panel height: totalHeight.
	panel fullBounds.
	^panel! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 8/27/2005 23:44'!
newPreferenceListPanel
	| panel |
	panel := Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellInset: 3;
		listCentering: #topLeft;
		listDirection: #topToBottom;
		cellPositioning: #topLeft;
		clipSubmorphs: true;
		addMorphBack: self newPreferenceListPanelLabel;
		addMorphBack: self preferenceList.
	^panel.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:29'!
newPreferenceListPanelLabel 
	^StringMorph contents: 'Preferences' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 02:55'!
newSearchButton
	^self basicButton
			label: 'search' translated; 
			actionSelector: #searchSelected;
			setBalloonText: 
				'Type what you want to search for here, then hit ',
				'the "Search" button, or else hit RETURN or ENTER' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 8/27/2005 23:44'!
newSearchPanel
	| bottom |
	bottom := Morph new
		color: Color transparent;
		cellInset: 5;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		addMorphBack: self newSearchTextField
		yourself.
	^Morph new
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		cellInset: 3;
		addMorphBack: (StringMorph contents: 'Search preferences for: ');
		addMorphBack: bottom;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'mt 8/1/2016 15:42'!
newSearchTextField
	
	| ptm  |
	ptm := PluggableTextMorphPlus
		on: self model
		text: #searchPatternNeverTriggered
		accept: #searchPattern:.
	
	ptm
		minimumHeight: 0;
		balloonText: 'Search preferences ...';
		hideScrollBarsIndefinitely;
		layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@ (TextStyle default lineGrid * 2)));
		borderInset;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		acceptOnCR: true;
		onKeyStrokeSend: #value to: [ ptm hasUnacceptedEdits ifTrue: [ ptm accept ] ].
	^ptm.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:51'!
newSeparator
	^BorderedMorph new
		borderWidth: 2;
		borderColor: Color transparent;
		color: self paneColor;
		hResizing: #rigid;
		width: 5;
		vResizing: #spaceFill;
		yourself! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:49'!
newTransparentFiller
	^Morph new
		color: Color transparent;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:24'!
pageDownKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex + self preferencesShowing size min: self selectedCategoryPreferences size).
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:30'!
pageUpKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex - self preferencesShowing size max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'mt 8/1/2016 17:11'!
preferenceList 
	^preferenceList ifNil:
		[preferenceList := ScrollPane new
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			layoutFrame: (LayoutFrame fractions: (0.25@0 corner: 1@1) offsets: (4@0 corner: 0@0)).
		preferenceList scroller
			on: #keyStroke send: #keyPressed: to: self.
		preferenceList.]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/18/2004 21:19'!
preferenceListInnerPanel
	^self preferenceList scroller submorphs first! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 00:29'!
preferencesShowing
	| prefs |
	prefs := self preferenceListInnerPanel submorphs
					copyFrom: (self selectedPreferenceIndex max: 1)
					to: self selectedCategoryPreferences size.
	^prefs reject: [:ea | (ea top - prefs first top) > self preferenceList scroller height].! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'mt 4/15/2015 07:05'!
rootPanel
	^BorderedMorph new
		color: Color transparent;
		borderWidth: 0;
		changeProportionalLayout;
		addMorphBack: self newSearchTextField;
		addMorphBack: self mainPanel;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'stephaneducasse 2/4/2006 20:39'!
rootPanelLayoutFrame 
	| frame |
	frame := self buttonRowLayoutFrame.
	^LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@(frame bottomOffset) corner: 0@0)! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:47'!
saveButton
	^saveButton ifNil: 
		[saveButton := self basicButton 
						label: 'save' translated; 
						action: #saveSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings as your personal defaults; you can get them all ',
							'reinstalled with a single gesture by clicking the "Restore ',
							'my Personal Preferences".' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/1/2016 15:48'!
saveToDiskButton
	^saveToDiskButton ifNil: 
		[saveToDiskButton := self basicButton 
						label: 'save to disk' translated; 
						action: #saveToDiskSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings to a file; you can get them all reinstalled with a ', 
							'single gesture by clicking "Restore Settings From Disk".'
								 translated]! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategory
	^self model selectedCategory! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex
	^self model selectedCategoryIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex: anIndex
	^self model selectedCategoryIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryPreferences
	^self model selectedCategoryPreferences! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedPreference
	^self model selectedPreference! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:50'!
selectedPreferenceButton
	^(self preferenceListInnerPanel submorphs at: self selectedPreferenceIndex)! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex
	^self model selectedPreferenceIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex: anIndex
	^self model selectedPreferenceIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:06'!
selectedPreference: aPreference
	^self model selectedPreference: aPreference! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'mt 8/5/2016 10:16'!
themeButton
	^themeButton ifNil: 
		[themeButton := self basicButton 
						label: 'more ...' translated; 
						action: #themeSelected;
						setBalloonText: 'Presents you with a menu of sets or preferences; each item''s balloon-help will tell you about the particular set.  If you choose one, many different preferences that come along are set at the same time; you can subsequently change any settings by using a Preferences Panel' translated].! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:54'!
turnOffSelectedPreference
	highlightedPreferenceButton 
		ifNil: [^self].
	highlightedPreferenceButton highlightOff.
	highlightedPreferenceButton := nil.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'kfr 11/6/2015 16:45'!
turnOnSelectedPreference
	
	highlightedPreferenceButton = self selectedPreferenceButton
		ifTrue: [ highlightedPreferenceButton highlightOff. ^self turnOffSelectedPreference].
	highlightedPreferenceButton 
		ifNotNil: [:m | m highlightOff].
	highlightedPreferenceButton := self selectedPreferenceButton
		highlightOn;
		yourself.
	self preferenceList scrollToShow: highlightedPreferenceButton bounds.! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 12/8/2004 19:10'!
updateSelectedCategoryPreferences
	Cursor wait showWhile: 
		[self preferenceList 
				hScrollBarValue: 0;
				vScrollBarValue: 0.
		self preferenceList scroller removeAllMorphs.
		self preferenceList scroller addMorphBack: self newPreferenceListInnerPanel.
		self adjustPreferenceListItemsWidth]! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'kfr 11/6/2015 16:45'!
updateSelectedPreference
	| index |
	index := self selectedPreferenceIndex.
	index = 0
		ifTrue: [^self].
	self turnOnSelectedPreference.! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 21:16'!
update: aSymbol
	super update: aSymbol.
	aSymbol == #selectedPreference
		ifTrue: [self updateSelectedPreference].
	aSymbol == #selectedCategoryIndex
		ifTrue: [self updateSelectedCategoryPreferences].! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
upKeyPressed: anEvent
	self selectedPreferenceIndex: 
			(self selectedPreferenceIndex - 1 max: 1).
! !

!PragmaPreference methodsFor: '*PreferenceBrowser' stamp: 'bf 3/4/2010 11:45'!
selectors
	"for browsing senders"
	^ {getter. setter}! !
PBBooleanPreferenceView initialize!
PBColorPreferenceView initialize!
PBHaloThemePreferenceView initialize!
PBNumericPreferenceView initialize!
PBTextPreferenceView initialize!
PreferenceViewRegistry initialize!
PreferenceBrowser initialize!
